using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;

namespace NeMech
{
    public class NeMechMenu: MVRScript
    {

		const string virsionMmsg = "=== NeMech_Menu V1.3 ===\n" +
		                           "PC-Paid Content.\n" +
		                           "Redistribution prohibited.\n" +
		                           "Alteration prohibited\nNeMech_Menu.cs \n" +
		                           "\nCreated by NeMech in 2022/09\n" +
		                           "Update by Nemech in 2022/11 \n" +
		                           "https://www.patreon.com/nemech\n\n" +
		                           "<color=#E00><b>HowToUse: </b></color>Add a plugin to the atom. (If you want to change the button size, it should not be the subject person.).If you have an object named 'NemechMenuHome', the button will appear there. If there is no object, it will appear in the default position\n" +
		                           "<color=yellow>*This will not work if there is more than one  female.</color>";

        const float BUTTON_SPACING_X = .3f;

        List<Atom> buttons = new List<Atom>();
        int buttonIndex = 0;

        DAZCharacterSelector geometry;
        List<bool> priorClothes = new List<bool>();
        bool dressed = true;

		private Atom targetAtom;

		private JSONStorableBool toggleClothCntrolle;
		private static JSONStorableFloat xSize;
		private static JSONStorableFloat ySize;
		private static JSONStorableFloat fontSize;
		private UIDynamicSlider dslider;


        public override void Init()
        {
            try
            {
				// put init code in here
				SuperController.LogMessage("NeMech Menu Loaded");

				// JSONStorableToggle  *** toggleClothes ***
				toggleClothCntrolle = new JSONStorableBool("toggleClothCntrolle", false, toggleClothCntrolleCallback);
				RegisterBool(toggleClothCntrolle);


				// JSONStorableString
				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=620f;

				// JSONStorableString
				pluginInfo = new JSONStorableString("moveInfo", "" );
				dtext = CreateTextField(pluginInfo,true);
				dtext.height=30f;
								

				// Check Target
				string TargetPersonName = SearchTgtFamale();

				if(TargetPersonName == ""){
					pluginInfo.val = "Target Famale atom is not found.\n<color=#E00><b>This plugin doesn't work</b></color>";
					OnDestroy();
				}
				targetAtom = SuperController.singleton.GetAtomByUid(TargetPersonName);

				// JSONStorableFloat
				xSize = new JSONStorableFloat("xSize", 500.0f, reSizeCallback, 100.0f, 2000.0f, true);
				dslider = CreateSlider(xSize,true);
				RegisterFloat(xSize);

				ySize = new JSONStorableFloat("ySize", 80.0f, reSizeCallback, 100.0f, 2000.0f, true);
				dslider = CreateSlider(ySize,true);
				RegisterFloat(ySize);

				fontSize = new JSONStorableFloat("fontSize", 50.0f, reSizeCallback, 10.0f, 400.0f, true);
				dslider = CreateSlider(fontSize,true);
				RegisterFloat(fontSize);

				// maybe need in override 
				DressController();

                StartCoroutine(Setup());
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
		private JSONStorableString jstring;
		private JSONStorableString pluginInfo;
		private UIDynamicTextField dtext;

		void reSizeCallback(JSONStorableFloat jf){
            int index = 0;
            buttons.ForEach((button) =>
            {
        	    button.GetStorableByID("Canvas").SetFloatParamValue("xSize", xSize.val);
    	        button.GetStorableByID("Canvas").SetFloatParamValue("ySize", ySize.val);
	            button.GetStorableByID("Text").SetFloatParamValue("fontSize", fontSize.val);
            	RestorePosition(button, buttons[0].mainController, index);
				index ++;
            } );
		}


        IEnumerator Setup()
        {
            yield return new WaitForSeconds(0.1f);


            CreateWorldButton("toggleClothes", () =>
            {
                SuperController.singleton.ShowMainHUD();
                SuperController.singleton.SelectController(targetAtom.mainController);
				ToggleDressed();
            }); 


            CreateWorldButton("Load Look", () =>
            {
                SuperController.singleton.ShowMainHUD();
                targetAtom.LoadAppearancePresetDialog();
	            dressed = true;
				SuperController.singleton.GetAtomByUid("toggleClothes").GetStorableByID("Text").SetStringParamValue("text", "undress");
            });

            yield return new WaitForSeconds(0.5f);

            int index = 0;
            buttons.ForEach((button) =>
            {
            	RestorePosition(button, buttons[0].mainController, index);
                index++;
            } );

		}

// 
		private void toggleClothCntrolleCallback(JSONStorableBool jf)
		{

			if(jf.val == dressed ){
				ToggleDressed();

			}
	
		}


        void CreateWorldButton(string buttonLabel, UnityEngine.Events.UnityAction call)
        {
            StartCoroutine(CreateWorldButtonCO(buttonLabel, call, buttonIndex++));
        }


        IEnumerator CreateWorldButtonCO(string buttonLabel, UnityEngine.Events.UnityAction call, int index)
        {



            Atom containingAtom = GetContainingAtom();

            string name = containingAtom.uid;
            string uid = buttonLabel;

            Atom atom = SuperController.singleton.GetAtomByUid(uid);

            if (atom == null)
            {
                yield return SuperController.singleton.AddAtomByType("UIButton", uid);

            }
            else
            {
                Debug.Log("button already exists");

                SuperController.singleton.RemoveAtom(atom);
                yield return SuperController.singleton.AddAtomByType("UIButton", uid);

            }

            atom = SuperController.singleton.GetAtomByUid(uid);

            atom.GetStorableByID("Text").SetStringParamValue("text", buttonLabel);

            UIButtonTrigger ubt = atom.GetStorableByID("Trigger") as UIButtonTrigger;
            ubt.button.onClick.AddListener(call);
        	
            atom.GetStorableByID("Canvas").SetFloatParamValue("xSize", xSize.val);
            atom.GetStorableByID("Canvas").SetFloatParamValue("ySize", ySize.val);
            HSVColor black = new HSVColor();
            black.H = 0; black.S = 0; black.V = .12f;

            HSVColor gray = new HSVColor();
            gray.H = 0; gray.S = 0; gray.V = 0.75f;

            atom.GetStorableByID("ButtonColor").SetFloatParamValue("alpha",0);
            atom.GetStorableByID("TextColor").SetColorParamValue("color", new HSVColor { H = 0.5034965f, S = 1f, V = 0.5607843f });

            atom.GetStorableByID("Text").SetFloatParamValue("fontSize", fontSize.val);

            FreeControllerV3 controller = atom.GetStorableByID("control") as FreeControllerV3;
            controller.deselectedMeshScale = 0.000f;

            SphereCollider collider = controller.GetComponent<SphereCollider>();
            collider.radius = 0.0f;
            collider.enabled = false;

            buttons.Add(atom);

        }

        public void ToggleDressed()
        {
            dressed = !dressed;

            if (!dressed)
            {

	            priorClothes = geometry.clothingItems.ToList().Select((clothing) =>
    	        {
        	        return clothing.active;
            	}).ToList();

                geometry.clothingItems.ToList().ForEach((clothing) =>
                {
                    if(! clothing.displayName.Contains("_cum_") & ! clothing.displayName.Contains("Eyes ")) { // force Molmark's _cum_ and Eyes
	                    geometry.SetActiveClothingItem(clothing, active: false);
                    }
                });
				SuperController.singleton.GetAtomByUid("toggleClothes").GetStorableByID("Text").SetStringParamValue("text", "wearClothes");
            }
            else
            {
                List<DAZClothingItem> clothes = geometry.clothingItems.ToList();
                for (int i = 0; i < priorClothes.Count; i++)
                {
                    geometry.SetActiveClothingItem(clothes[i], priorClothes[i]);
                    if(clothes[i].displayName.Contains("_cum_") & clothes[i].displayName.Contains("Eyes ")) { // force Molmark's _cum_and Eyes
						geometry.SetActiveClothingItem(clothes[i], active: true);
					}
                }
				SuperController.singleton.GetAtomByUid("toggleClothes").GetStorableByID("Text").SetStringParamValue("text", "undress");
            }

        }

        public void DressController()
        {
            JSONStorable geometryStorable = targetAtom.GetStorableByID("geometry");
            geometry = geometryStorable as DAZCharacterSelector;

            priorClothes = geometry.clothingItems.ToList().Select((clothing) =>
            {
                return clothing.active;
            }).ToList();
            dressed = true;
        }


        void RestorePosition(Atom atom, FreeControllerV3 controller, int index)
        {

            if (atom == null)
            {
                return;
            }

            if (controller == null)
            {
                return;
            }
			int x;
			int y;

			y=index%4;
			x=index/4;


			var receivingAtom = SuperController.singleton.GetAtomByUid("NemechMenuHome");
			if(receivingAtom == null){
                atom.mainController.transform.Translate( 0f, 0f, 0f);
                atom.mainController.transform.SetPositionAndRotation(controller.transform.position, controller.transform.rotation);
			} else {
				atom.GetStorableByID("control").transform.position = receivingAtom.GetStorableByID("control").transform.position;
				atom.GetStorableByID("control").transform.rotation = receivingAtom.GetStorableByID("control").transform.rotation ;
			}

//              atom.mainController.transform.Translate(0, -BUTTON_SPACING_Y * y, - BUTTON_SPACING_X * x, Space.World);
              atom.mainController.transform.Translate(0, -( ySize.val/80.0f * 0.048f) * y, - BUTTON_SPACING_X * x, Space.World);
              atom.SetOn(true);
              atom.SetBoolParamValue("on",true);
              atom.GetStorableByID("AtomControl").SetBoolParamValue("hidden",true);

        }

		public static Vector3 CloneX(Vector3 vec)
    	{
        		return new Vector3(vec.x, vec.y, vec.z);
		}

        void OnDestroy()
        {
            buttons.ForEach((button) =>
            {
                if (button != null)
                {
                    SuperController.singleton.RemoveAtom(button);
                }
            });
        }

// NemechL

		private string SearchTgtFamale() {
			string rval;
			int count;
			rval = "";
			count = 0;

			SuperController.singleton.GetAtoms().ForEach((atom)=>
			{
				if(atom.type == "Person" & atom.on == true ) {
					if( atom.GetComponentInChildren<DAZCharacterSelector>().gender == DAZCharacterSelector.Gender.Female ){
						rval = atom.name;
						count ++;
					}
				}
			});
			if(count == 1){
				return rval;
			} else {
				return "";
			}
		}

	}


}
