using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.EventSystems;
using UnityEngine.Events;

namespace NeMech
{

    public class VRDildo: MVRScript
    {


		const string virsionMmsg = "<b>=== VRDild V2.3 ===</b>\n" + 
		                           "PC-Paid Content.\n" +
		                           "<color=purple>Redistribution prohibited.</color>\n" +
		                           "Alteration prohibited\n" +
		                           "VRDildo.cs\n\n" +
		                           "Created by NeMech in 2022/08\n" +
		                           "LastUpdate by Nemech in 2022/12 \n" +
		                           "https://www.patreon.com/nemech";
		
		private int counter; 
		private float stopCount;
		private bool direction;
		private bool activeLock; // 短時間での再起動防止、3秒にするか
				
		private Vector3 peniT_H;
		private Vector3 peniB_H;
		private Vector3 peniB_I;
		private Vector3 peniB_T;
		private Vector3 peniB_O;
		private Vector3 peniT_O;
		private float speed_aj;
		private Quaternion peniB_B;			// 方向転換向けのバックアップ(オリジナル)
		private Quaternion peniB_BB;		// 方向転換向けのバックアップ(変更バックアップ)
		
		private Quaternion peniOperationR;
		
		JSONStorableFloat cycleTime;	
		JSONStorableFloat insertOffset;
		JSONStorableFloat penetrationDepth;
		JSONStorableFloat XAngle;
		JSONStorableFloat YAngle;
		JSONStorableFloat XPos;
		JSONStorableFloat YPos;
		JSONStorableFloat ZPos;
		JSONStorableFloat FwPos;


		JSONStorableFloat distancePerTime;
		JSONStorableFloat sensingThreshold;
		

        public FreeControllerV3 peniBIndex;
        public FreeControllerV3 peniB;
        private FreeControllerV3 peniT;

        
        private Vector3 VRHand;
        private Vector3 speed;
        private Quaternion VRrotation;
		private float angleV;

		private int pass;
		private char[] di;
		private bool colF;

        public override void Init()
        {
            try
            {

				SuperController.LogMessage("NeMech VRDildo Loaded");
				activeLock = false;

				// JSONStorableToggle  *** cctiveStatus ***
				activeStatus = new JSONStorableBool("activeStatus", false, activeStatusCallback);
				RegisterBool(activeStatus);
				CreateToggle(activeStatus, false);

				// JSONStorableToggle *** playHand **** 
				playHand = new JSONStorableBool("playHand(check:Left)", false);
				RegisterBool(playHand);
				CreateToggle(playHand, false);

				// JSONStorableToggle *** playMode **** 
				playMode = new JSONStorableBool("playMode(uncheck:autoMove)", false);
				RegisterBool(playMode);
				CreateToggle(playMode, false);

				// JSONStorableFloat
				cycleTime = new JSONStorableFloat("cycleTime", 44.0f, DummyFloatCallback, 10.0f, 60.0f, true);
				RegisterFloat(cycleTime);
				dslider = CreateSlider(cycleTime,true);

				// JSONStorableFloat
				insertOffset = new JSONStorableFloat("insertOffset", 0.0f, DummyFloatCallback, -1.0f, 1.0f, true);
				RegisterFloat(insertOffset);
				dslider = CreateSlider(insertOffset,true);

				// JSONStorableFloat
				penetrationDepth = new JSONStorableFloat("penetrationDepth", 0.0f, DummyFloatCallback, 0.0f, 1.2f, true);
				RegisterFloat(penetrationDepth);
				dslider = CreateSlider(penetrationDepth,true);

				// NotStorableToggle
				XAngle = new JSONStorableFloat("XAngle", 0.0f, angleChange, -80.0f, 80.0f, true);
				RegisterFloat(XAngle);
				dslider = CreateSlider(XAngle,false);

				// NotStorableToggle
				YAngle = new JSONStorableFloat("YAngle", 0.0f, angleChange, -80.0f, 80.0f, true);
				RegisterFloat(YAngle);
				dslider = CreateSlider(YAngle,false);


				// NotStorableToggle
				XPos = new JSONStorableFloat("XPos", 0.0f, positionChange, -0.2f, 0.2f, true);
				RegisterFloat(XPos);
				dslider = CreateSlider(XPos,false);

				// NotStorableToggle
				YPos = new JSONStorableFloat("YPos", 0.0f, positionChange, -0.2f, 0.2f, true);
				RegisterFloat(YPos);
				dslider = CreateSlider(YPos,false);

				// NotStorableToggle
				ZPos = new JSONStorableFloat("ZPos", 0.0f, positionChange, -0.2f, 0.2f, true);
				RegisterFloat(ZPos);
				dslider = CreateSlider(ZPos,false);

				// NotStorableToggle
				FwPos = new JSONStorableFloat("FwPos", 0.0f, positionChange, -0.2f, 0.2f, true);
				RegisterFloat(FwPos);
				dslider = CreateSlider(FwPos,false);


				// JSONStorableFloat
				distancePerTime = new JSONStorableFloat("VR distancePerTime", 20.0f, DummyFloatCallback, 1.0f, 100.0f, true);
				RegisterFloat(distancePerTime);
				dslider = CreateSlider(distancePerTime,true);

				// JSONStorableFloat
				sensingThreshold = new JSONStorableFloat("VR sensingThreshold", 4f, DummyFloatCallback, 1f, 15f, true);
				RegisterFloat(sensingThreshold);
				dslider = CreateSlider(sensingThreshold,true);

				// JSONStorableToggle MenuOn 
				screenMenu = new JSONStorableBool("ScreenMenu", true ,ScreenMenuCallback);
				screenMenu.val = false;
				RegisterBool(screenMenu);
				CreateToggle(screenMenu, true);

				// JSONStorableToggle XZ 
				XZalignment = new JSONStorableBool("XZalignment", true );
				XZalignment.val = false;
				RegisterBool(XZalignment);
				CreateToggle(XZalignment, true);


				// JSONStorableString
				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=360f;


				// JSONStorableString
				pluginInfo = new JSONStorableString("moveInfo", "" );
				dtext = CreateTextField(pluginInfo,true);
				dtext.height=30f;


		di = new char[5];


				Invoke("initialWaitSub",1.0f);

             }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }


        }

		private void initialWaitSub(){

				if(activeStatus.val == true){
					activeStatus.toggle.isOn=true;
				} else {
					activeStatus.toggle.isOn=true;
					activeStatus.toggle.isOn=false;
					unActiveLock();
				}

		}

		private JSONStorableString jstring;
		private JSONStorableString pluginInfo;
		private JSONStorableStringChooser jchooser;
		private UIDynamicSlider dslider;
		private UIDynamicButton dbutton;
		private UIDynamicButton dbuttonStart;
		protected JSONStorableAction manualSwTrigger;

		private JSONStorableBool activeStatus;
		private JSONStorableBool playHand;
		private JSONStorableBool playMode;
		private JSONStorableBool screenMenu;
		private JSONStorableBool XZalignment;

		private UIDynamicTextField dtext;

		IEnumerator ActionButtonCallback() {

			if( activeStatus.val == true ){
				
				if(containingAtom.type != "Person"){
		    		peniB = containingAtom.GetStorableByID("control") as FreeControllerV3;
		    		peniB_O = peniB.transform.localPosition;
					peniT_O = peniB.transform.localPosition;
					peniT_H = peniB.transform.localPosition;
		    		peniB.transform.localPosition = peniB.transform.localPosition - transform.forward * 10f * 0.01f;

				} else {
					peniB = containingAtom.GetStorableByID("penisBaseControl") as FreeControllerV3;
		    		peniB_O = peniB.transform.localPosition;
					peniT_O = peniB.transform.localPosition;
					peniT_H = peniB.transform.localPosition;

					colF = false;
		            StartCoroutine(CreateWorldDildoIndexCO("indexDildo", peniB ));

					while(colF == false){
			            yield return new WaitForSeconds(0.02f);
					}

					peniBIndex = SuperController.singleton.GetAtomByUid("indexDildo").containingAtom.GetStorableByID("control") as FreeControllerV3;
		    		peniB.transform.position = peniBIndex.transform.position - peniBIndex.transform.forward * 10f * 0.01f;
				}
				
				peniB_B = peniB.transform.localRotation; //　回転機能オプション
				peniB_BB = peniB_B;
				XAngle.val = 0.0f;
				YAngle.val = 0.0f;


				peniB.currentPositionState = FreeControllerV3.PositionState.On;
				peniB.currentRotationState = FreeControllerV3.RotationState.On;
				peniB_H = peniB.transform.localPosition;

				peniOperationR = peniB.transform.localRotation ; // 操作戻し用


				counter = (int) cycleTime.val;
				direction = true; 
				DummyFloatCallback(distancePerTime) ;

			} else {
				peniB.transform.localPosition = peniB_O;
				peniB.transform.localRotation = peniB_BB;
				activeLock = true;				// Lock
				Invoke("unActiveLock",1.0f);	// unLock
			}

			XPos.val = 0.0f;
			YPos.val = 0.0f;
			ZPos.val = 0.0f;

			pluginInfo.val = "actionInfo:" + activeStatus.val ;

		}

		private void unActiveLock()
		{
			activeLock = false;
		}


		private void DummyFloatCallback(JSONStorableFloat jf) {

			peniB_T = peniT_H + (peniT_H - peniB_H ) * penetrationDepth.val*1.5f+(peniT_H - peniB_H ) * (insertOffset.val);
			peniB_I = peniB_H +(peniT_H - peniB_H ) * (insertOffset.val);

			Vector3 distVec = peniB_T - peniB_I;
			peniB_T= peniB_I + distVec;
			speed_aj = (cycleTime.val)/60.0f ;
			
		}

		// Angle変更時の動作
		private void angleChange(JSONStorableFloat jf){
			if(peniB_BB == peniB.transform.localRotation ){
				peniB.transform.localRotation = peniB_B;
				peniB.transform.Rotate(XAngle.val,YAngle.val,0.0f);
				peniB_BB = peniB.transform.localRotation;
			} else {
				if(jf.name=="XAngle"){
					peniB.transform.Rotate( - XAngle.val,0f ,0.0f);
					peniB_BB = peniB_B = peniB.transform.localRotation;
					YAngle.val = 0f;
					if(screenMenu.val == true ) SuperController.singleton.GetAtomByUid("X Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.0f);
				}
				if(jf.name=="YAngle"){
					peniB.transform.Rotate( 0f ,- YAngle.val,0.0f);
					peniB_BB = peniB_B = peniB.transform.localRotation;
					XAngle.val = 0f;
					if(screenMenu.val == true ) SuperController.singleton.GetAtomByUid("Y Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.0f);
				}
			}

		// Fw 位置のリセット
			peniB_O = peniB_O + peniB.transform.forward * FwPos.val;
			FwPos.val =0f;
		}


		private void activeStatusCallback(JSONStorableBool jf){
				if(activeLock == true){
					activeStatus.val = false;
//					SuperController.singleton.GetAtomByUid("activeStatus").GetStorableByID("Trigger").SetBoolParamValue("value",false);
					return ;
				}
				StartCoroutine(ActionButtonCallback());
		}

		// Position変更時の動作
		private void positionChange(JSONStorableFloat jf){

			if(activeStatus.val != true){

				if( peniB.transform.hasChanged == false ){
					peniB.transform.localPosition = peniB_O + Vector3.forward * ZPos.val + Vector3.left*XPos.val + Vector3.up*YPos.val + peniB.transform.forward * FwPos.val;
				} else {

					Vector3 targetWork;
					targetWork = peniB.transform.localPosition;

					if(jf.name == "YPos") {
						targetWork = targetWork - Vector3.up*YPos.val;
					} else {
						if(screenMenu.val == true ) SuperController.singleton.GetAtomByUid("Y Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);					
						YPos.val =0f;
					}

					if(jf.name == "XPos") {
						targetWork = targetWork - Vector3.left*XPos.val;
					} else {
						if(screenMenu.val == true ) SuperController.singleton.GetAtomByUid("X Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);					
						XPos.val =0f;
					}

					if(jf.name == "ZPos") {
						targetWork = targetWork - Vector3.forward*ZPos.val;
					} else {
						if(screenMenu.val == true ) SuperController.singleton.GetAtomByUid("Z Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);					
						ZPos.val =0f;
					}

					if(jf.name == "FwPos") {
						targetWork = targetWork - peniB.transform.forward * FwPos.val;
					} else {
						if(screenMenu.val == true ) SuperController.singleton.GetAtomByUid("Fw Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);					
						FwPos.val =0f;
					}

					peniB_O = targetWork;
					peniB.transform.hasChanged = false;
				}

			} else {
				if( XPos.val != 0.0f )  { SuperController.singleton.GetAtomByUid("X Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f); XPos.val = 0.0f; }
				if( YPos.val != 0.0f )  { SuperController.singleton.GetAtomByUid("Y Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f); YPos.val = 0.0f; }
				if( ZPos.val != 0.0f )  { SuperController.singleton.GetAtomByUid("Z Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f); ZPos.val = 0.0f; }
				if( FwPos.val != 0.0f ) { SuperController.singleton.GetAtomByUid("Fw Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f); FwPos.val =0.0f; }
			}
			
		}

        IEnumerator CreateWorldDildoIndexCO(string indexLabel, FreeControllerV3 controller )
		{
		    Atom atom = SuperController.singleton.GetAtomByUid(indexLabel);
            if (atom == null)
            {
//                Debug.Log("indexDildo Create");
            	yield return SuperController.singleton.AddAtomByType("Dildo", indexLabel);

            }
            else
            {
//                Debug.Log("indexDildo already exists");
//				SuperController.LogError("indexDildo already exists");
//                SuperController.singleton.RemoveAtom(atom);
//                yield return SupxzerController.singleton.AddAtomByType("Dildo", indexLabel);

            }

			atom = SuperController.singleton.GetAtomByUid(indexLabel);
			atom.GetStorableByID("control").transform.position = controller.transform.position;
			atom.GetStorableByID("control").transform.rotation = controller.transform.rotation ;
			atom.SetOn(false);
			atom.GetStorableByID("AtomControl").SetBoolParamValue("hidden",true);
			colF = true;
		}




// CreateMenu


		void ScreenMenuCallback(JSONStorableBool jf)
		{

			if(screenMenu.val == true ){

				if(buttonIndex != 0){
					if(buttons[0] == null){
	            	   	buttonIndex = 0;
						buttons = new List<Atom>();
					}
				}
				
				
				
				if(buttonIndex == 0 ){
					StartCoroutine(MenuSetup());// Menu			
				} else {
		            int index = 0;
		            buttons.ForEach((button) =>
		            {
            			RestorePosition(button, buttons[0].mainController, index);
		                index++;
		            } );
				}
			} else {
				
				buttons.ForEach((button) =>
	            {
                	if (button != null)
            	    {
        	            button.SetOn(false);
            	    }
	            });	            
			}
		}

        const float BUTTON_SPACING_Y = .06f;
        const float BUTTON_SPACING_X = .3f;

        const float BUTTON_WIDTH = 500f;
        const float BUTTON_HIGHT = 80f;
        
        const float SLIDER_WIDTH = 500f;
        const float SLIDER_HIGHT = 160f;

        const float FONT_SIZE = 55f;
        const float ALPH_VALU = 0f;

        const int MAX_VERTICAL = 7;

        List<Atom> buttons = new List<Atom>();


        List<HSVColor> textColor = new List<HSVColor>();
        int buttonIndex = 0;

        IEnumerator MenuSetup()
        {
        	textColor.Add(new HSVColor{H = 0.0867091f, S = 0.3581071f , V = 0.7983264f});  // 0.gold
        	textColor.Add(new HSVColor{H = 0.7622842f, S = 0.3828832f , V = 0.9480315f});   // 1.perpl
        	textColor.Add(new HSVColor{H = 0.3333333f, S = 1f , V = 0.7333333f});         // 2.green
        	textColor.Add(new HSVColor{H = 0.4852246f, S = 0.5604699f , V = 0.848174f});         // 2.cian
        
        
            yield return new WaitForSeconds(0.1f);


            CreateWorldToggle("activeStatus", () =>
            {
				if(activeStatus.val){
					SuperController.singleton.GetAtomByUid("activeStatus").GetStorableByID("Trigger").SetBoolParamValue("value",false);
					activeStatus.toggle.isOn=false;
				} else {
					SuperController.singleton.GetAtomByUid("activeStatus").GetStorableByID("Trigger").SetBoolParamValue("value",true);
					activeStatus.toggle.isOn=true;				
				}

				SuperController.singleton.GetAtomByUid("X Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);
				SuperController.singleton.GetAtomByUid("Y Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);
				SuperController.singleton.GetAtomByUid("X Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);
				SuperController.singleton.GetAtomByUid("Y Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);
				SuperController.singleton.GetAtomByUid("Z Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);
				SuperController.singleton.GetAtomByUid("Fw Position").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);

				XAngle.val = 0f;
				YAngle.val = 0f;
				XPos.val = 0f;
				YPos.val = 0f;
				ZPos.val = 0f;
				FwPos.val = 0f;

            } ,0 );

            CreateWorldToggle("VRDildo", () =>
            {
				if(playMode.val){
					playMode.toggle.isOn=false;
				} else {
					playMode.toggle.isOn=true;
				}

            } , 0 );
            CreateWorldToggle("VR Hand(L/R)" , () =>
            {
				if(playHand.val){
					playHand.toggle.isOn=false;
				} else {
					playHand.toggle.isOn=true;				
				}

            } ,0 );


            CreateWorldSlider("Cycle",  insertCycleF ,1);
            CreateWorldSlider("penetrationDepth",  penetrationDepthF ,1);
            CreateWorldSlider("insertOffset",  insertOffsetF ,1);
            CreateWorldSlider("DildoSize",  DildoSizexF ,0);

            CreateWorldSlider("X Angle",  XAngleF ,3);
            CreateWorldSlider("Y Angle",  YAngleF ,3);

            CreateWorldSlider("X Position",  XPosF ,2);
            CreateWorldSlider("Y Position",  YPosF ,2);
            CreateWorldSlider("Z Position",  ZPosF ,2);
            CreateWorldSlider("Fw Position",  FwPosF ,2);


            yield return new WaitForSeconds(0.1f);

			SuperController.singleton.GetAtomByUid("Cycle").GetStorableByID("Trigger").SetFloatParamValue("value",0.8f);
			SuperController.singleton.GetAtomByUid("penetrationDepth").GetStorableByID("Trigger").SetFloatParamValue("value",0.0f);
            int index = 0;
            buttons.ForEach((button) =>
            {
            	RestorePosition(button, buttons[0].mainController, index);
                index++;
            } );
		}

		private void DildoSizexF(float value){
			if(containingAtom.type == "Dildo" ){
				containingAtom.GetStorableByID("scale").SetFloatParamValue("scale",1.2f*value +0.5f);
			}else {
				SuperController.singleton.GetAtomByUid("DildoSize").SetOn(false);
			}
		}

		private void insertOffsetF(float value){
			insertOffset.val = 2f*value - 1f;
		}

		private void insertCycleF(float value){
			cycleTime.val = 50f*value + 10f;
		}

		private void penetrationDepthF(float value){
			penetrationDepth.val = 1.2f*value;
		}

		private void XAngleF(float value){
			if(peniOperationR == peniB.transform.localRotation){
				YAngle.val = (value -0.5f) *160;
				peniB.transform.localRotation = peniB_B;
				peniB.transform.Rotate(XAngle.val,YAngle.val,0.0f);
				peniOperationR = peniB.transform.localRotation;
			} else {
				peniB_B = peniB.transform.localRotation;
				peniOperationR = peniB_B;
				XAngle.val = 0.5f;
				YAngle.val = 0.5f;

				SuperController.singleton.GetAtomByUid("X Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);
				SuperController.singleton.GetAtomByUid("Y Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);

			}
		}

		private void YAngleF(float value){
			if(peniOperationR == peniB.transform.localRotation){
				XAngle.val = (value -0.5f) *160;
				peniB.transform.localRotation = peniB_B;
				peniB.transform.Rotate(XAngle.val,YAngle.val,0.0f);
				peniOperationR = peniB.transform.localRotation;
			} else {
				peniB_B = peniB.transform.localRotation;
				peniOperationR = peniB_B;
				XAngle.val = 0.5f;
				YAngle.val = 0.5f;
				
				SuperController.singleton.GetAtomByUid("X Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);
				SuperController.singleton.GetAtomByUid("Y Angle").GetStorableByID("Trigger").SetFloatParamValue("value",0.5f);

			}
		}

		private void XPosF(float value){
			XPos.val = (value - 0.5f) * 0.4f;
		}

		private void YPosF(float value){
			YPos.val = (value - 0.5f) * 0.4f;
		}

		private void ZPosF(float value){
			ZPos.val = (value - 0.5f) * 0.4f;
		}

		private void FwPosF(float value){
			FwPos.val = (value - 0.5f) * 0.4f;
		}

        void CreateWorldToggle(string toggleLabel , UnityEngine.Events.UnityAction call ,int txtColor)
        {
            StartCoroutine(CreateWorldToggleCO(toggleLabel, call, buttonIndex++ ,txtColor));
        }


        IEnumerator CreateWorldToggleCO(string toggleLabel, UnityEngine.Events.UnityAction call, int index ,int txtColor)
		{
            string uid = toggleLabel;		

		    Atom atom = SuperController.singleton.GetAtomByUid(uid);
            if (atom == null)
            {
                yield return SuperController.singleton.AddAtomByType("UIToggle", uid);

            }
            else
            {
                Debug.Log("toggle already exists");

                SuperController.singleton.RemoveAtom(atom);
                yield return SuperController.singleton.AddAtomByType("UIToggle", uid);

            }
            atom = SuperController.singleton.GetAtomByUid(uid);
            UIToggleTrigger ubt = atom.GetStorableByID("Trigger") as UIToggleTrigger;
            ubt.toggle.onValueChanged.AddListener(delegate {
			call(); 
			});


// form


            atom.GetStorableByID("Text").SetStringParamValue("text", toggleLabel);

            atom.GetStorableByID("Canvas").SetFloatParamValue("xSize", BUTTON_WIDTH);
            atom.GetStorableByID("Canvas").SetFloatParamValue("ySize", BUTTON_HIGHT);
            HSVColor black = new HSVColor();
            black.H = 0; black.S = 0; black.V = .12f;

            HSVColor gray = new HSVColor();
            gray.H = 0; gray.S = 0; gray.V = 0.75f;

            atom.GetStorableByID("SliderColor").SetFloatParamValue("alpha",ALPH_VALU);
            atom.GetStorableByID("TextColor").SetColorParamValue("color", textColor[txtColor]);

            atom.GetStorableByID("Text").SetFloatParamValue("fontSize", FONT_SIZE);

            FreeControllerV3 controller = atom.GetStorableByID("control") as FreeControllerV3;
            controller.deselectedMeshScale = 0.000f;

            SphereCollider collider = controller.GetComponent<SphereCollider>();
            collider.radius = 0.0f;
            collider.enabled = false;




            buttons.Add(atom); // これは表示時に使うぽい。
		}

        void RestorePosition(Atom atom, FreeControllerV3 controller, int index)
        {

            if (atom == null)
            {
                return;
            }

            if (controller == null)
            {
                return;
            }
			int Xpos ;
			float Ypos ;

			Ypos = index%MAX_VERTICAL;
			Xpos = Mathf.FloorToInt(index/MAX_VERTICAL);

			var receivingAtom = SuperController.singleton.GetAtomByUid("VRDildoMenuHome");
			if(receivingAtom == null){
                atom.transform.Translate( 0f, 0f, 0f);
                atom.transform.SetPositionAndRotation(controller.transform.position, controller.transform.rotation);
			} else {
				atom.GetStorableByID("control").transform.position = receivingAtom.GetStorableByID("control").transform.position;
				atom.GetStorableByID("control").transform.rotation = receivingAtom.GetStorableByID("control").transform.rotation ;
			}

			int i = 0;
			float YposD = 0;
			while(Ypos>i){
				if(buttons[Xpos *4 + i].type == "UISlider" ){
					YposD = YposD + 0.6f;
				}
				i++;
			}
			Ypos = Ypos + YposD;


			if( atom.type == "UISlider" ){
				if(XZalignment.val == false)
					atom.transform.Translate(- BUTTON_SPACING_X * Xpos , -BUTTON_SPACING_Y * (Ypos +0.6f),0 , Space.World);
				else
					atom.transform.Translate(0 , -BUTTON_SPACING_Y * (Ypos +0.6f),- BUTTON_SPACING_X * Xpos , Space.World);
			} else {
				if(XZalignment.val == false)
					atom.transform.Translate(- BUTTON_SPACING_X * Xpos , -BUTTON_SPACING_Y * Ypos ,0 , Space.World);			
				else
					atom.transform.Translate(0 , -BUTTON_SPACING_Y * Ypos ,- BUTTON_SPACING_X * Xpos , Space.World);			
			}

              atom.GetStorableByID("AtomControl").SetBoolParamValue("hidden",true);
              atom.SetOn(true);
              atom.GetStorableByID("control").SetBoolParamValue("canGrabPosition",false);
              atom.GetStorableByID("control").SetBoolParamValue("canGrabRotation",false);


        }


// Slider
//UnityAction
        void CreateWorldSlider(string sliderLabel, UnityEngine.Events.UnityAction<float> call ,int txtColor)
        {
            StartCoroutine(CreateWorldSliderCO(sliderLabel, call, buttonIndex++ ,txtColor));
        }


        IEnumerator CreateWorldSliderCO(string sliderLabel, UnityEngine.Events.UnityAction<float> call, int index ,int txtColor)
		{
            string uid = sliderLabel;		

		    Atom atom = SuperController.singleton.GetAtomByUid(uid);
            if (atom == null)
            {
                yield return SuperController.singleton.AddAtomByType("UISlider", uid);

            }
            else
            {
                Debug.Log("slider already exists");

                SuperController.singleton.RemoveAtom(atom);
                yield return SuperController.singleton.AddAtomByType("UISlider", uid);

            }		

            atom = SuperController.singleton.GetAtomByUid(uid);
            UISliderTrigger ubt = atom.GetStorableByID("Trigger") as UISliderTrigger;

			ubt.slider.value = 0.5f;
            ubt.slider.onValueChanged.AddListener( call );

//form

			atom.GetStorableByID("Text").SetStringParamValue("text", sliderLabel);

            atom.GetStorableByID("Canvas").SetFloatParamValue("xSize", SLIDER_WIDTH);
            atom.GetStorableByID("Canvas").SetFloatParamValue("ySize", SLIDER_HIGHT);
            HSVColor black = new HSVColor();
            black.H = 0; black.S = 0; black.V = .12f;

            HSVColor gray = new HSVColor();
            gray.H = 0; gray.S = 0; gray.V = 0.75f;

            atom.GetStorableByID("SliderColor").SetFloatParamValue("alpha",ALPH_VALU);
            atom.GetStorableByID("TextColor").SetColorParamValue("color", textColor[txtColor]);


            atom.GetStorableByID("Text").SetFloatParamValue("fontSize", FONT_SIZE);

            FreeControllerV3 controller = atom.GetStorableByID("control") as FreeControllerV3;
            controller.deselectedMeshScale = 0.000f;

            SphereCollider collider = controller.GetComponent<SphereCollider>();
            collider.radius = 0.0f;
            collider.enabled = false;


            buttons.Add(atom); // これは表示時に使うぽい。
		}




		void Start() {

		}

		void Update() {

			Vector3 velocity = Vector3.zero;

			if(activeStatus.val == true) {
				counter = counter - 1;

				if(counter > 0 ) {
					if(! playMode.val == true){ 
							if(direction == true ) {
								if(stopCount <= 0.0f){
								peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_I,ref velocity,0.07f*speed_aj);

								} else {
									stopCount --;
									counter ++;
								}
							} else {
									peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_T,ref velocity,0.1f*speed_aj);
							}
					} else {
						if(pass<=0){
						if(playHand.val){ 
							speed = (VRHand - SuperController.singleton.leftHand.transform.position);
							angleV = Quaternion.Angle(VRrotation,SuperController.singleton.leftHand.transform.rotation);
						} else {
							speed = (VRHand - SuperController.singleton.rightHand.transform.position);
							angleV = Quaternion.Angle(VRrotation,SuperController.singleton.rightHand.transform.rotation);						
						}


						if((( angleV > 0.7) || (speed.magnitude > sensingThreshold.val/1000)) ){

						if(speed.y > 0){
							di[0]=(char)1;
						} else {
							di[0]=(char)0;
						}
							if( (di[0]+di[1]+di[2]) >= 2 ){                                               
								peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_T,ref velocity, distancePerTime.val/1000f);
							} else {
								peniB.transform.localPosition = Vector3.SmoothDamp(peniB.transform.localPosition,peniB_I,ref velocity,distancePerTime.val/1000f);
							}
						di[4]=di[3];
						di[3]=di[2];
						di[2]=di[1];
						di[1]=di[0];
						}
						if(playHand.val){
							VRHand = SuperController.singleton.leftHand.transform.position;
							VRrotation = SuperController.singleton.leftHand.transform.rotation;

						} else {
							VRHand = SuperController.singleton.rightHand.transform.position;
							VRrotation = SuperController.singleton.rightHand.transform.rotation;
						}
							pass = 3;
						}
						pass = pass -1;
					}
				} else {
					counter= (int) cycleTime.val;
					direction = !direction;
					if( cycleTime.val > 55 )
						stopCount = 100.0f;
					else
						stopCount = cycleTime.val/2.0f -1;
				}
			}
		}

        void OnDestroy()
        {
            buttons.ForEach((button) =>
            {
                if (button != null)
                {
                    SuperController.singleton.RemoveAtom(button);
                }
            });

        	Atom atom = SuperController.singleton.GetAtomByUid("indexDildo");
        	SuperController.singleton.RemoveAtom(atom);
        
        }


    }

}